#!/usr/bin/env python3
# @generated AUTOGENERATED file. Do not Change!

from dataclasses import dataclass, field as _field
from ...config import custom_scalars, datetime
from gql_client.runtime.variables import encode_variables
from gql import gql, Client
from gql.transport.exceptions import TransportQueryError
from functools import partial
from numbers import Number
from typing import Any, AsyncGenerator, Dict, List, Generator, Optional
from time import perf_counter
from dataclasses_json import DataClassJsonMixin, config

from ..fragment.property import PropertyFragment, QUERY as PropertyFragmentQuery


# fmt: off
QUERY: List[str] = PropertyFragmentQuery + ["""
query EquipmentTypeAndPropertiesQuery($id: ID!) {
  equipment: node(id: $id) {
    ... on Equipment {
      equipmentType {
        name
      }
      properties {
        ...PropertyFragment
      }
    }
  }
}

"""
]


class EquipmentTypeAndPropertiesQuery:
    @dataclass(frozen=True)
    class EquipmentTypeAndPropertiesQueryData(DataClassJsonMixin):
        @dataclass(frozen=True)
        class Node(DataClassJsonMixin):
            @dataclass(frozen=True)
            class EquipmentType(DataClassJsonMixin):
                name: str

            @dataclass(frozen=True)
            class Property(PropertyFragment):
                pass

            equipmentType: EquipmentType
            properties: List[Property]

        equipment: Optional[Node]

    # fmt: off
    @classmethod
    def execute(cls, client: Client, id: str) -> Optional[EquipmentTypeAndPropertiesQueryData.Node]:
        variables: Dict[str, Any] = {"id": id}
        new_variables = encode_variables(variables, custom_scalars)
        response_text = client.execute(
            gql("".join(set(QUERY))), variable_values=new_variables
        )
        res = cls.EquipmentTypeAndPropertiesQueryData.from_dict(response_text)
        return res.equipment

    # fmt: off
    @classmethod
    async def execute_async(cls, client: Client, id: str) -> Optional[EquipmentTypeAndPropertiesQueryData.Node]:
        variables: Dict[str, Any] = {"id": id}
        new_variables = encode_variables(variables, custom_scalars)
        response_text = await client.execute_async(
            gql("".join(set(QUERY))), variable_values=new_variables
        )
        res = cls.EquipmentTypeAndPropertiesQueryData.from_dict(response_text)
        return res.equipment
